<template>
  <div class="UserInfo">
    <el-header class="topHeader">
      <el-row>
        <el-col :span="6" class="tongjiIcon">
          <el-image :src="tongjiIcon" :fit="fill" style="
                height: 40px;
                width: 160px;
                float: left;
                margin: 15px 20px 0px 0px;
              ">
          </el-image>
          <span style="display: inline-block;line-height:70px;font-size: 27px;">德育分管理系统</span>
        </el-col>
        <el-col :span='8' :offset=1 style="margin-top: 20px">
          <el-menu :default-active="activeIndex" mode="horizontal" background-color="#f8f8f8">
            <el-menu-item class="nav" index="1"><a href="http://124.70.41.6:8080/profile">个人主页</a></el-menu-item>
            <!--<el-menu-item class="nav" index="1" @click="toProfile">个人主页</el-menu-item>-->
            <el-menu-item class="nav" index="2"><a href="http://124.70.41.6:8080/activities_detailed">活动浏览</a>
            </el-menu-item>
            <el-menu-item class="nav" index="3" v-if="author != 3"><a href="http://124.70.41.6:8080/activities_verify">活动审核</a>
            </el-menu-item>
            <el-menu-item class="nav" index="4" v-if="author != 3"><a href="http://124.70.41.6:8080/permission_list">权限变更</a></el-menu-item>
          </el-menu>
        </el-col>
        <el-col :span="1" :offset="6">
          <el-badge :value="messageNum" class="item">
            <notification />
          </el-badge>
        </el-col>
        <el-col :span="1">
          <el-dropdown>
            <span class="el-dropdown-link">
              <img class="profile" :src="this.useravatar" alt="">
              <el-icon class="el-icon--right">
                <arrow-down />
              </el-icon>
            </span>
            <template #dropdown>
              <el-dropdown-menu>
                <el-dropdown-item ><a href="http://124.70.41.6:8080/profile">个人主页</a></el-dropdown-item>
                <el-dropdown-item @click="dialogVisible = true">
                  绑定学院
                </el-dropdown-item>
                <el-dropdown-item @click="handleToChangePWD">修改密码</el-dropdown-item>
                  
                <el-dropdown-item @click="logout">登出</el-dropdown-item>



              </el-dropdown-menu>
            </template>
          </el-dropdown>
        </el-col>
      </el-row>
    </el-header>
    <el-dialog v-model="dialogVisible"  title="绑定学院" width="30%" draggable>
      <el-form v-model="form" label-width="170px" style="position:relative;top:1px;">
          <el-form-item label="学号" >
              <el-input style="width:250px" v-model="form.number" placeholder="请输入学号"></el-input>
          </el-form-item>
          <el-form-item label="学院绑定码">
              <el-input style="width:250px" v-model="form.bindCode" placeholder="请输入学院绑定码"></el-input>
          </el-form-item>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="dialogVisible = false">关闭窗口</el-button>
          <el-button type="primary" @click="bindFunc">进行绑定</el-button>
        </span>
      </template>
  </el-dialog>
  </div>
</template>

<script>
import axios from "axios";
import { ArrowDown } from '@element-plus/icons-vue'
import global from "./Common.vue"
import { ref } from 'vue'
import notification from './notification.vue'
import BindCollege from './BindCollege.vue'
export default {
  name: "Base",
  emits: ['getuser'],
  data() {
    return {
      email: "",
      tongjiIcon: require("../assets/images/tongjiIcon.png"),
      ip: global.ip,
      BindCollegeDialogVisible: true,
      user: {
        permission: this.permissionid
      },
      useravatar: "",
      messageNum: 0,
      dialogVisible: false,
      author: '',
      form: {
        number: '',
        bindCode: '',
      }
    }
  },
  toProfile(){
    // this.$router.push("/profile")
    alert("请自行跳转");
    console.log("is that ok");
    window.location.replace("http://" + global.ip_front + "profile");
    
  },
  created() {
    this.$emit('getuser', this.user);
    const author = localStorage.getItem('author')
    this.author = author
    console.log(author, 'au')
    let token = localStorage.getItem('token');
    axios({
      method: "POST",
      url: "http://" + global.ip + "/api/notice/newnum",
      headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
      this.messageNum = res.data.num ? res.data.num : 0
    })
    // 请求用户头像
    axios({
      method: "POST",
      url: "http://" + this.ip + "/api/user/avatar",
      data: {
        
      },
      responseType: 'blob',
      headers: { Authorization: `Bearer: ${token}` }
    }).then((res) => {
      console.log(res.data)
      this.useravatar = window.URL.createObjectURL(res.data);
      console.log(this.UserProfileImg)
    });
  },
  methods: {
    handleToChangePWD() {
      this.$router.push("/modify_pass")
      // localStorage.removeItem("token");
      // window.location.replace("http://124.70.41.6:8080/login");
      // axios({
      //   method: "POST",
      //   url: "http://" + this.ip + "/api/user/modifypwd",
      //   data: {

      //   }
      // }).then((res) => {
      //   console.log(res);
      // })
    },
    logout() {
      this.$router.push("/login?frame=3")
      localStorage.removeItem("token");
      window.location.replace("http://" + global.ip_front + "/login");
      axios({
        method: "POST",
        url: "http://" + this.ip + "/api/user/logout",
        data: {
        }
      }).then((res) => {
        console.log(res);
      })
    },
    bindFunc() {
      let token = localStorage.getItem("token");
      const { number, bindCode } = this.form
      axios({
          method: "POST",
          url: "http://" + global.ip + "/api/user/bind",
          headers: { Authorization: `Bearer: ${token}` },
          data: {
              number,
              bindCode,
          }
      }).then((res) => {
          // console.log(res);
          this.$message(res.data.msg)
      });
    }
  },
  components: {
    notification,
    BindCollege
  },
  props: ['email', 'activeIndex', 'permissionid', 'avatar']
}
</script>

<style scoped>
.topHeader {
  background-color: #f8f8f8;
  color: #123456;
  line-height: 60px;
  margin-bottom: 1px;
  height: 76px;
}

.tongjiIcon {
  color: #1c98ce;
  font-size: 20px;
  font-weight: bold;
  text-align: left;
}

.tongjiIcon span {
  font-size: 30px;
}

.nav {
  font-family: -apple-system, SF UI Text, Arial, PingFang SC, Hiragino Sans GB, Microsoft YaHei, WenQuanYi Micro Hei, sans-serif;
  font-size: 20px;
  font-weight: 3px;
  bottom: 10px;
}

.profile {
  height: 50px;
  width: 50px;
  border-radius: 50%;
  position: relative;
  top: 10px;
  left: 20px;
}

/deep/.item>sup {
  right: 6px;
  top: 20px;
}

#bell {
  height: 40px;
  position: relative;
  top: 20px;
}

a {
  text-decoration: none;
}
</style>